#ifndef _LINUX_NOOKS_SYS_H
#define _LINUX_NOOKS_SYS_H

#include <linux/unistd.h>
long nooks_create_nook(char * name);
long nooks_delete_nook(char * name);
long nooks_query_nook(char * name, 
		      int which, 
		      char * buf, 
		      size_t bufsize, 
		      size_t * ret);

long nooks_enum_nooks(char * buf, 
		      size_t bufsize, 
		      size_t * ret);

long nooks_ioctl(char * name, unsigned int cmd, unsigned long arg);

long nooks_unload_nook(char * name);

typedef struct swifi_result {
  unsigned long address;
  unsigned long old;
  unsigned long new;
} swifi_result_t, *pswifi_result_t;

long
swifi_inject_fault(char * nook_name,
		   unsigned long faultType,
		   unsigned long randSeed,
		   unsigned long numFaults,
		   void * results,
		   unsigned long do_inject);

//
// Test kmalloc functionality
// nook required: yes
// arg: size to alloc
//

#define NOOKS_IOCTL_TEST_KMALLOC        100
#define NOOKS_IOCTL_TEST_VMALLOC        101
#define NOOKS_IOCTL_VALIDATE_NOOKS      102
#define NOOKS_IOCTL_DUMP_DATA           103
#define NOOKS_IOCTL_DUMP_DATA_MM              1
#define NOOKS_IOCTL_DUMP_DATA_DRIVERS         2
#define NOOKS_IOCTL_DUMP_DATA_RESOURCES       4
#define NOOKS_IOCTL_DUMP_DATA_RES_HIST        8

#define NOOKS_IOCTL_SET_CSWITCH         104
#define NOOKS_IOCTL_CSWITCH_FLUSH_TLB         1
#define NOOKS_IOCTL_CSWITCH_INT               2

#define NOOKS_IOCTL_SET_GLOBAL_FLAG     105
#define NOOKS_IOCTL_SET_DEBUG_FLAG      106


#define NOOKS_IOCTL_DUMP_PAGETABLE      107
#define NOOKS_IOCTL_COMP_PAGETABLE      108
#define NOOKS_IOCTL_COMP_PAGETABLE_PROT 1
#define NOOKS_IOCTL_PROTECT_PAGETABLE   109
#define NOOKS_IOCTL_SYS_PAGETABLE       110
#define NOOKS_IOCTL_CALL_AGENT          111
#define NOOKS_IOCTL_DUMMY_CALL          112
#define NOOKS_IOCTL_DUMMY_IWRAPPER_CALL 113
#define NOOKS_IOCTL_PROTECT_JUST_PAGETABLE   114
#define NOOKS_IOCTL_FAULT               115

#define NOOKS_IOCTL_LAST                9999

#define NOOKS_ARG_HIGH(_x_, _b_)	 ((unsigned int) ((_x_) >> (_b_)))
#define NOOKS_ARG_LOW(_x_, _b_)          ((unsigned int) ((_x_) & ((1U << (_b_)) - 1)))

#define NOOKS_MAKE_ARG(_l_, _h_, _b_)	 ((unsigned int) ((_h_) << (_b_)) + (_l_))


#define NOOKS_QUERY_STATE               1

#endif // _LINUX_NOOKS_SYS_H

